#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#ifdef BSD
# include <strings.h>
#else
# include <string.h>
#endif

#ifdef DEBUG
#include <stdio.h>

extern int mcs_verbose;
#endif

char* mcsname_bysocket(fd)
int fd;
{
	struct sockaddr_in sck;
	int scksz=sizeof(sck);
	struct hostent *he;
	char *p;

	if (getsockname(fd,(struct sockaddr*)&sck,&scksz) < 0)
	{
#ifdef DEBUG
		if (mcs_verbose) perror("getsockname");
#endif
		return NULL; /* this is not a socket, no translations */
	}

#ifdef DEBUG
	if (mcs_verbose > 1)
		fprintf(stderr,"getsockname returned 0x%8lx\n",
				(unsigned long)sck.sin_addr.s_addr);
#endif

	if ((he=gethostbyaddr((char *)&sck.sin_addr.s_addr,
		sizeof(sck.sin_addr.s_addr),
		sck.sin_family)) == NULL) {
#ifdef DEBUG
		if (mcs_verbose) perror("gethostbyaddr");
#endif
		return "/"; /* cannot back-resolve local address:
			this is severe problem, we better hush
			the user away.  Let him try when the
			nameserver is operational again. */
	}

	if ((p=strchr(he->h_name,'.'))) *p='\0';

	return he->h_name;
}
